"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var MATCH_DESTROYED_ERROR = 'MatchDestroyedError';
var MATCH_ERROR = 'MatchError';
var MATCH_REPLAY_FILE_ERROR = 'MatchReplayFileError';
var MATCH_ERROR_LOG_FILE_ERROR = 'MatchErrorLogFileError';
/**
 * @class MatchError
 * Errors thrown by the {@link Match} class
 */
var MatchError = /** @class */ (function (_super) {
    __extends(MatchError, _super);
    function MatchError(m) {
        var _this = _super.call(this, m) || this;
        _this.name = MATCH_ERROR;
        Object.setPrototypeOf(_this, MatchError.prototype);
        return _this;
    }
    return MatchError;
}(Error));
exports.MatchError = MatchError;
/**
 * Error thrown when a match is explicitly destroyed (by the user generally) by calling {@link Match.destroy}
 */
var MatchDestroyedError = /** @class */ (function (_super) {
    __extends(MatchDestroyedError, _super);
    function MatchDestroyedError(m) {
        var _this = _super.call(this, m) || this;
        _this.name = MATCH_DESTROYED_ERROR;
        Object.setPrototypeOf(_this, MatchDestroyedError.prototype);
        return _this;
    }
    return MatchDestroyedError;
}(MatchError));
exports.MatchDestroyedError = MatchDestroyedError;
/**
 * Errors related to replay files
 */
var MatchReplayFileError = /** @class */ (function (_super) {
    __extends(MatchReplayFileError, _super);
    function MatchReplayFileError(m) {
        var _this = _super.call(this, m) || this;
        _this.name = MATCH_REPLAY_FILE_ERROR;
        Object.setPrototypeOf(_this, MatchReplayFileError.prototype);
        return _this;
    }
    return MatchReplayFileError;
}(MatchError));
exports.MatchReplayFileError = MatchReplayFileError;
/**
 * Errors related to log files
 */
var MatchErrorLogFileError = /** @class */ (function (_super) {
    __extends(MatchErrorLogFileError, _super);
    function MatchErrorLogFileError(m) {
        var _this = _super.call(this, m) || this;
        _this.name = MATCH_ERROR_LOG_FILE_ERROR;
        Object.setPrototypeOf(_this, MatchErrorLogFileError.prototype);
        return _this;
    }
    return MatchErrorLogFileError;
}(MatchError));
exports.MatchErrorLogFileError = MatchErrorLogFileError;
//# sourceMappingURL=index.js.map