/**
 * Various system related utilities
 */
export declare const LOCAL_DIR: string;
/**
 * Removes a file synchronously
 * @param file - file to remove
 */
export declare const removeFileSync: (file: string) => void;
/**
 * Removes a file
 * @param file - file to remove
 */
export declare const removeFile: (file: string) => Promise<void>;
export declare const processIsRunning: (pid: number) => boolean;
/**
 * Removes files in the given directory synchronously
 * @param dir
 */
export declare const removeDirectorySync: (dir: string) => void;
/**
 * Removes files in the given directory
 * @param dir
 */
export declare const removeDirectory: (dir: string) => Promise<void>;
/**
 * Writes a file from given `file` path to `destination`. Auto creates directories as needed
 * @param file
 * @param destination
 */
export declare const writeFileToDestination: (file: string, destination: string) => Promise<void>;
/**
 * Effectively runs the `docker cp` command
 * @param fileOrDirectoryPath
 * @param container
 * @param targetPath
 */
export declare const dockerCopy: (fileOrDirectoryPath: string, containerID: string, targetPath: string) => Promise<void>;
